//+------------------------------------------------------------------+
//|                                                  BrainTrend2.mq4 |
//|                                     BrainTrading Inc. System 7.0 |
//|                                     http://www.braintrading.com  |
//+------------------------------------------------------------------+
#property copyright "BrainTrading Inc. System 7.0"
#property link      "http://www.braintrading.com"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- 
double Ind_Buffer1[];
double Ind_Buffer2[];
double spread;
//----
bool   river=True;
int    artp,limit,Curr,glava;
double dartp,cecf,Emaxtra,widcha,TR;
double Values[1],ATR,Weight,val1,val2,low,high,Series1;
//----        
bool   RIVER;int time2,GLAVA;double EMAXTRA,VALUES[1];
//+------------------------------------------------------------------+
//| BrainTrend2 initialization function                              |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Ind_Buffer2);
   spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
//----  
   dartp=7.0; cecf=0.7; artp=7;  
//----     
   ArrayResize( Values, artp);
//----          
   ArrayResize( VALUES, artp);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| BrainTrend2 iteration function                                   |
//+------------------------------------------------------------------+
int start()
  {
//----       
if (Bars < 11)return(0);
//----+        
int limit,MaxBar,bar,J,counted_bars=IndicatorCounted();
//----    
if (counted_bars<0)return(-1);
//----       
if (counted_bars>0) counted_bars--;
//----     ,        
MaxBar=Bars-3;
//----     ,         
limit=(Bars-1-counted_bars);
//----  
if(limit>=MaxBar)
 {
  limit = MaxBar;
  Emaxtra = Close[limit+1];
  glava=0;
  double T_Series2=Close[limit+2];
  double T_Series1=Close[limit+1];
  if(T_Series2 > T_Series1) river = True; else river = False;
  for (int ii=Bars-1; ii>MaxBar;ii--)
   { 
    Ind_Buffer1[ii]=0.0;
    Ind_Buffer2[ii]=0.0;
   }
 } 
//----
//+---    +================+
int Tnew=Time[limit+1];
if (limit<MaxBar)
 if (Tnew==time2)
   {
    for(int xx=0;xx<=artp-1;xx++)Values[xx]=VALUES[xx];
    glava=GLAVA;
    Emaxtra=EMAXTRA;
    river = RIVER;
   }  
 else
  {
   if (Tnew>time2)Print("ERROR01");
   else Print("ERROR02");
   return(-1);  
  }
//+--- +==================================================+
//+---     
bar=limit;
while(bar>=0)      
   {  
      //+---    +=============+ 
      if (bar==1)
         if(((limit==1)&&(time2!=Time[2]))||(limit>1))
           {
            for(int kk=0;kk<=artp-1;kk++)VALUES[kk]=Values[kk];
            GLAVA=glava;
            EMAXTRA=Emaxtra;
            RIVER=river;
            time2=Time[2];
           }
      //+---+============================================+
      Series1=Close[bar+1];
      low=Low [bar];high=High[bar];
      TR = spread + high - low;
      if( MathAbs(spread + high - Series1) > TR ) TR = MathAbs(spread + high - Series1);
      if( MathAbs(low - Series1) > TR)  TR = MathAbs(low - Series1);
      if (bar == MaxBar)for(J=0;bar<=artp-1;J++)Values[J] = TR;    
 		Values[glava] = TR;
      ATR = 0;
      Weight = artp;
      Curr = glava;
      for (J = 0;J<=artp - 1;J++) 
      {
      ATR += Values[Curr] * Weight;
      Weight -= 1.0;
      Curr--;
      if (Curr == -1) Curr = artp - 1;
      }
      ATR = 2.0 * ATR / (dartp * (dartp + 1.0));
      glava++;
      if (glava == artp) glava = 0;
      widcha = cecf * ATR;
      if (river && low < Emaxtra - widcha) 
      {
         river = False;
         Emaxtra = spread + high;
      }
      if (!river && spread + high > Emaxtra + widcha) 
      {
         river = True;
         Emaxtra = low;
      }
      if (river && low > Emaxtra) 
      {
         Emaxtra = low;
      }
      if (!river && spread + high < Emaxtra ) 
      {
         Emaxtra = spread + high;
      }
      //Range1 = iATR(NULL,0,10,bar);
      if( river==true ) 
      {
         val1 = high;
         val2 = low;
      } 
      else 
      {
         val1 = low;
         val2 = high;
      }
      Ind_Buffer1[bar]=val1;
      Ind_Buffer2[bar]=val2;  
      bar--;
   }  
//+---   
   return(0);
  }